=== modified file 'NEWS'
--- NEWS	2005-10-18 23:47:12 +0000
+++ NEWS	2005-10-19 06:01:01 +0000
@@ -117,6 +117,10 @@
       missing on EmptyTree, leading to a bug with merge on EmptyTrees.
       (Robert Collins)
 
+    * WorkingTree.__del__ has been removed, it was non deterministic and not 
+      doing what it was intended to. See WorkingTree.__init__ for a comment
+      about future directions. (Robert Collins/Martin Pool)
+
   BUG FIXES:
 
     * Better handling of branches in directories with non-ascii names. 

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2005-10-18 23:47:12 +0000
+++ bzrlib/workingtree.py	2005-10-19 06:01:01 +0000
@@ -141,6 +141,10 @@
 
         # update the whole cache up front and write to disk if anything changed;
         # in the future we might want to do this more selectively
+        # two possible ways offer themselves : in self._unlock, write the cache
+        # if needed, or, when the cache sees a change, append it to the hash
+        # cache file, and have the parser take the most recent entry for a
+        # given path only.
         hc = self._hashcache = HashCache(basedir)
         hc.read()
         hc.scan()
@@ -148,12 +152,6 @@
         if hc.needs_write:
             mutter("write hc")
             hc.write()
-            
-            
-    def __del__(self):
-        if self._hashcache.needs_write:
-            self._hashcache.write()
-
 
     def __iter__(self):
         """Iterate through file_ids for this tree.

